unit EditControlImpl;

interface

uses
  ComObj, ActiveX, Collection_TLB, StdVcl, StdCtrls;

type
  TEditControl = class(TAutoIntfObject, IEditControl)
  private
    FApplication: IApplication;
    FEdit: TEdit;
  protected
    function Get_Application: IApplication; safecall;
    function Get_Name: WideString; safecall;
    function Get_Text: WideString; safecall;
    procedure Clear; safecall;
    procedure Set_Text(const Value: WideString); safecall;
    { Protected declarations }
  public
    constructor Create(Application: IApplication; Edit: TEdit);
  end;

implementation

uses
  ComServ;

constructor TEditControl.Create(Application: IApplication; Edit: TEdit);
begin
  inherited Create(ComServer.TypeLib, IEditControl);
  FApplication := Application;
  FEdit := Edit
end;

function TEditControl.Get_Application: IApplication;
begin
  Result := FApplication
end;

function TEditControl.Get_Name: WideString;
begin
  Result := FEdit.Name
end;

function TEditControl.Get_Text: WideString;
begin
  Result := FEdit.Text
end;

procedure TEditControl.Set_Text(const Value: WideString);
begin
  FEdit.Text := Value
end;

procedure TEditControl.Clear;
begin
  FEdit.Clear
end;

end.
