unit ClockClient2MainForm;

interface

uses
  Clock_TLB,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls;

type
  TClockClientForm = class(TForm)
    btnSetAlarm: TButton;
    Timer1: TTimer;
    Bar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnSetAlarmClick(Sender: TObject);
  private
    FSinkCookie: Integer;
  public
    ClockServer: IApplication;
  end;

var
  ClockClientForm: TClockClientForm;

implementation

{$R *.DFM}

uses
  ComObj, ClockClient2Impl;

procedure TClockClientForm.FormCreate(Sender: TObject);
const
  ProgID = 'Clock.Application';
begin
  try
    ClockServer := GetActiveOleObject(ProgID) as IApplication;
  except
    ClockServer := CreateOleObject(ProgID) as IApplication;
  end;
  //No need to keep hold of event sink. It will be destroyed
  //through interface reference counting when the client
  //disconnects from the server in the form's OnDestroy event handler
  InterfaceConnect(ClockServer, IApplicationEvents, TClockSink.Create, FSinkCookie)
end;

procedure TClockClientForm.FormDestroy(Sender: TObject);
begin
  InterfaceDisconnect(ClockServer, IApplicationEvents, FSinkCookie);
end;

procedure TClockClientForm.Timer1Timer(Sender: TObject);
begin
  try
    Bar.Panels[0].Text := DateTimeToStr(ClockServer.CurrentDateTime);
    if ClockServer.AlarmSet then
      Bar.Panels[1].Text := 'Alarm set'
    else
      Bar.Panels[1].Text := 'Alarm not set';
  except
    Bar.Panels[0].Text := 'N/A';
    Bar.Panels[1].Text := 'N/A';
  end
end;

procedure TClockClientForm.btnSetAlarmClick(Sender: TObject);
begin
  if not ClockServer.AlarmSet then
    ClockServer.Alarm := Now + (5 / SecsPerDay)
  else
    ShowMessage('Alarm already set!')
end;

end.
