unit ClockImpl;

interface

uses
  ComObj, ActiveX, Hierarchy_TLB, StdVcl;

type
  TClock = class(TAutoIntfObject, IClock)
  private
    FApplication: IApplication;
  protected
    function Get_Date: TDateTime; safecall;
    function Get_DateTime: TDateTime; safecall;
    function Get_DayOfWeek: TDayOfWeek; safecall;
    function Get_Time: TDateTime; safecall;
    function Get_Application: IApplication; safecall;
    { Protected declarations }
  public
    constructor Create(const Application: IApplication);
  end;

implementation

uses
  SysUtils, ComServ;

constructor TClock.Create(const Application: IApplication);
begin
  inherited Create(ComServer.TypeLib, IClock);
  FApplication := Application
end;

function TClock.Get_Date: TDateTime;
begin
  Result := Date
end;

function TClock.Get_DateTime: TDateTime;
begin
  Result := Now
end;

function TClock.Get_DayOfWeek: TDayOfWeek;
begin
  Result := DayOfWeek(Now)
end;

function TClock.Get_Time: TDateTime;
begin
  Result := Time
end;

function TClock.Get_Application: IApplication;
begin
  Result := FApplication
end;

end.
